searchNodes=[{"doc":"Ecto/Postgrex types to work with the PostgreSQL IP4R extension. Setup Define a module with the required :postgrex extensions added: Postgrex.Types.define( MyApp.PostgrexTypes, EctoIPRange.Postgrex.extensions() ++ Ecto.Adapters.Postgres.extensions() ) Add this module to your :ecto repo configuration: config :my_app, MyRepo, types: MyApp.PostgrexTypes Usage Define the appropriate field type in your schema: defmodule MySchema do use Ecto.Schema schema &quot;test_schema_ip4&quot; do :my_ip_range_field, EctoIPRange.IP4 end end The following fields are currently supported: Single Addresses EctoIPRange.IP4 EctoIPRange.IP6 Address Ranges EctoIPRange.IP4R EctoIPRange.IP6R Migrations To use the fields in migrations you need to either access the underlying type atom or specify the type atom directly: defmodule MyRepo.Migration do use Ecto.Migration def change do create table(&quot;my_table&quot;) do add :direct, :ip4r add :underlying, EctoIPRange.IP4R.type() end end end Changesets To insert a database record with an IP range field you need to ensure the internal type is properly casted. For example using a changeset: %MySchema{} |&gt; Ecto.Changeset.cast(%{ip4_address: &quot;1.2.3.4&quot;}, [:ip4_address]) |&gt; Ecto.Changeset.validate_required([:ip4_address]) |&gt; MyRepo.insert!() Please refer to the individual types to see what values are accepted.","ref":"EctoIPRange.html","title":"EctoIPRange","type":"module"},{"doc":"Provides a simple list of available :postgrex extension modules.","ref":"EctoIPRange.Postgrex.html","title":"EctoIPRange.Postgrex","type":"module"},{"doc":"Returns all available :postgrex extension modules.","ref":"EctoIPRange.Postgrex.html#extensions/0","title":"EctoIPRange.Postgrex.extensions/0","type":"function"},{"doc":"Struct for PostgreSQL :ip4. Usage When used during a changeset cast the following values are accepted: :inet.ip4_address(): an IP4 tuple, e.g. {127, 0, 0, 1} binary: binary representation, e.g. &quot;127.0.0.1&quot; EctoIPRange.IP4.t(): a pre-casted struct Fields ip","ref":"EctoIPRange.IP4.html","title":"EctoIPRange.IP4","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"EctoIPRange.IP4.html#embed_as/1","title":"EctoIPRange.IP4.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"EctoIPRange.IP4.html#equal?/2","title":"EctoIPRange.IP4.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP4.html#t:t/0","title":"EctoIPRange.IP4.t/0","type":"type"},{"doc":"Struct for PostgreSQL :ip4r. Usage When used during a changeset cast the following values are accepted: :inet.ip4_address(): an IP4 tuple, e.g. {127, 0, 0, 1} (single address only) binary &quot;127.0.0.1&quot;: single address &quot;127.0.0.0/24&quot;: CIDR notation for a range from 127.0.0.0 to 127.0.0.255 &quot;127.0.0.1-127.0.0.2&quot;: arbitrary range EctoIPRange.IP4R.t(): a pre-casted struct Fields range first_ip last_ip","ref":"EctoIPRange.IP4R.html","title":"EctoIPRange.IP4R","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"EctoIPRange.IP4R.html#embed_as/1","title":"EctoIPRange.IP4R.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"EctoIPRange.IP4R.html#equal?/2","title":"EctoIPRange.IP4R.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP4R.html#t:t/0","title":"EctoIPRange.IP4R.t/0","type":"type"},{"doc":"Struct for PostgreSQL :ip6. Usage When used during a changeset cast the following values are accepted: :inet.ip6_address(): an IP6 tuple, e.g. {8193, 3512, 34211, 0, 0, 35374, 880, 29492} binary: binary representation, e.g. &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334&quot; EctoIPRange.IP6.t(): a pre-casted struct IP4 addresses (binary and tuple) will be converted to IP6 format when casted. Fields ip","ref":"EctoIPRange.IP6.html","title":"EctoIPRange.IP6","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"EctoIPRange.IP6.html#embed_as/1","title":"EctoIPRange.IP6.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"EctoIPRange.IP6.html#equal?/2","title":"EctoIPRange.IP6.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP6.html#t:t/0","title":"EctoIPRange.IP6.t/0","type":"type"},{"doc":"Struct for PostgreSQL :ip6r. Usage When used during a changeset cast the following values are accepted: :inet.ip6_address(): an IP6 tuple, e.g. {8193, 3512, 34211, 0, 0, 35374, 880, 29492} (single address only) binary &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334&quot;: single address &quot;2001:0db8:85a3:0000:0000:8a2e:0370:0000/112&quot;: CIDR notation for a range from 2001:0db8:85a3:0000:0000:8a2e:0370:0000 to 2001:0db8:85a3:0000:0000:8a2e:0370:ffff &quot;2001:0db8:85a3:0000:0000:8a2e:0370:7334-2001:0db8:85a3:0000:0000:8a2e:0370:7335&quot;: arbitrary range EctoIPRange.IP4.t(): a pre-casted struct IP4 addresses (binary and tuple) will be converted to IP6 format when casted. Fields range first_ip last_ip","ref":"EctoIPRange.IP6R.html","title":"EctoIPRange.IP6R","type":"module"},{"doc":"Callback implementation for Ecto.Type.embed_as/1.","ref":"EctoIPRange.IP6R.html#embed_as/1","title":"EctoIPRange.IP6R.embed_as/1","type":"function"},{"doc":"Callback implementation for Ecto.Type.equal?/2.","ref":"EctoIPRange.IP6R.html#equal?/2","title":"EctoIPRange.IP6R.equal?/2","type":"function"},{"doc":"","ref":"EctoIPRange.IP6R.html#t:t/0","title":"EctoIPRange.IP6R.t/0","type":"type"},{"doc":"Postgrex extension for &quot;ip4&quot; fields.","ref":"EctoIPRange.Postgrex.IP4Extension.html","title":"EctoIPRange.Postgrex.IP4Extension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1.","ref":"EctoIPRange.Postgrex.IP4Extension.html#decode/1","title":"EctoIPRange.Postgrex.IP4Extension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1.","ref":"EctoIPRange.Postgrex.IP4Extension.html#encode/1","title":"EctoIPRange.Postgrex.IP4Extension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1.","ref":"EctoIPRange.Postgrex.IP4Extension.html#format/1","title":"EctoIPRange.Postgrex.IP4Extension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1.","ref":"EctoIPRange.Postgrex.IP4Extension.html#init/1","title":"EctoIPRange.Postgrex.IP4Extension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1.","ref":"EctoIPRange.Postgrex.IP4Extension.html#matching/1","title":"EctoIPRange.Postgrex.IP4Extension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;ip4r&quot; fields.","ref":"EctoIPRange.Postgrex.IP4RExtension.html","title":"EctoIPRange.Postgrex.IP4RExtension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1.","ref":"EctoIPRange.Postgrex.IP4RExtension.html#decode/1","title":"EctoIPRange.Postgrex.IP4RExtension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1.","ref":"EctoIPRange.Postgrex.IP4RExtension.html#encode/1","title":"EctoIPRange.Postgrex.IP4RExtension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1.","ref":"EctoIPRange.Postgrex.IP4RExtension.html#format/1","title":"EctoIPRange.Postgrex.IP4RExtension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1.","ref":"EctoIPRange.Postgrex.IP4RExtension.html#init/1","title":"EctoIPRange.Postgrex.IP4RExtension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1.","ref":"EctoIPRange.Postgrex.IP4RExtension.html#matching/1","title":"EctoIPRange.Postgrex.IP4RExtension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;ip6&quot; fields.","ref":"EctoIPRange.Postgrex.IP6Extension.html","title":"EctoIPRange.Postgrex.IP6Extension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1.","ref":"EctoIPRange.Postgrex.IP6Extension.html#decode/1","title":"EctoIPRange.Postgrex.IP6Extension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1.","ref":"EctoIPRange.Postgrex.IP6Extension.html#encode/1","title":"EctoIPRange.Postgrex.IP6Extension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1.","ref":"EctoIPRange.Postgrex.IP6Extension.html#format/1","title":"EctoIPRange.Postgrex.IP6Extension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1.","ref":"EctoIPRange.Postgrex.IP6Extension.html#init/1","title":"EctoIPRange.Postgrex.IP6Extension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1.","ref":"EctoIPRange.Postgrex.IP6Extension.html#matching/1","title":"EctoIPRange.Postgrex.IP6Extension.matching/1","type":"function"},{"doc":"Postgrex extension for &quot;ip6r&quot; fields.","ref":"EctoIPRange.Postgrex.IP6RExtension.html","title":"EctoIPRange.Postgrex.IP6RExtension","type":"module"},{"doc":"Callback implementation for Postgrex.Extension.decode/1.","ref":"EctoIPRange.Postgrex.IP6RExtension.html#decode/1","title":"EctoIPRange.Postgrex.IP6RExtension.decode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.encode/1.","ref":"EctoIPRange.Postgrex.IP6RExtension.html#encode/1","title":"EctoIPRange.Postgrex.IP6RExtension.encode/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.format/1.","ref":"EctoIPRange.Postgrex.IP6RExtension.html#format/1","title":"EctoIPRange.Postgrex.IP6RExtension.format/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.init/1.","ref":"EctoIPRange.Postgrex.IP6RExtension.html#init/1","title":"EctoIPRange.Postgrex.IP6RExtension.init/1","type":"function"},{"doc":"Callback implementation for Postgrex.Extension.matching/1.","ref":"EctoIPRange.Postgrex.IP6RExtension.html#matching/1","title":"EctoIPRange.Postgrex.IP6RExtension.matching/1","type":"function"}]